Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | List of all members
Botan::Hex_Encoder Class Referencefinal

`#include <hex_filt.h>`

Inheritance diagram for Botan::Hex_Encoder:

## Public Types
enum | Case { Uppercase, Lowercase }

## Public Member Functions
virtual bool | attachable ()
void | end_msg () override
| Hex_Encoder (Case the_case)
| Hex_Encoder (bool newlines=false, size_t line_length=72, Case the_case=Uppercase)
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t in[], size_t length) override

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

Converts arbitrary binary data to hex strings, optionally with newlines inserted

Definition at line 19 of file hex_filt.h.

## Member Enumeration Documentation

enum Botan::Hex_Encoder::Case

Whether to use uppercase or lowercase letters for the encoded string.

Enumerator
Uppercase |
Lowercase |

Definition at line 25 of file hex_filt.h.

25 { Uppercase, Lowercase };
Botan::Hex_Encoder::Uppercase
Definition: hex_filt.h:25
Botan::Hex_Encoder::Lowercase
Definition: hex_filt.h:25

## Constructor & Destructor Documentation

Botan::Hex_Encoder::Hex_Encoder | ( | Case | the_case | ) |
| explicit

Create a hex encoder.

Parameters

  the_case | the case to use in the encoded strings.

Definition at line 36 of file hex_filt.cpp.

36 : m_casing(c), m_line_length(0)
37 {
38 m_in.resize(HEX_CODEC_BUFFER_SIZE);
39 m_out.resize(2*m_in.size());
40 m_counter = m_position = 0;
41 }
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:20

Botan::Hex_Encoder::Hex_Encoder | ( | bool | newlines = `false`,
|  | size_t | line_length = `72`,
|  | Case | the_case = `Uppercase`
| ) |  |

Create a hex encoder.

Parameters

  newlines | should newlines be used
  line_length | if newlines are used, how long are lines
  the_case | the case to use in the encoded strings

Definition at line 25 of file hex_filt.cpp.

25 :
26 m_casing(c), m_line_length(breaks ? length : 0)
27 {
28 m_in.resize(HEX_CODEC_BUFFER_SIZE);
29 m_out.resize(2*m_in.size());
30 m_counter = m_position = 0;
31 }
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:20

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

void Botan::Hex_Encoder::end_msg | ( |  | ) |
| override virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 99 of file hex_filt.cpp.

References Botan::Filter::send().

100 {
101 encode_and_send(m_in.data(), m_position);
102 if(m_counter && m_line_length)
103 send('\n');
104 m_counter = m_position = 0;
105 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

std::string Botan::Hex_Encoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 27 of file hex_filt.h.

27 { return "Hex_Encoder"; }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

void Botan::Hex_Encoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 76 of file hex_filt.cpp.

References Botan::buffer_insert(), and Botan::copy_mem().

77 {
78 buffer_insert(m_in, m_position, input, length);
79 if(m_position + length >= m_in.size())
80 {
81 encode_and_send(m_in.data(), m_in.size());
82 input += (m_in.size() - m_position);
83 length -= (m_in.size() - m_position);
84 while(length >= m_in.size())
85 {
86 encode_and_send(input, m_in.size());
87 input += m_in.size();
88 length -= m_in.size();
89 }
90 copy_mem(m_in.data(), input, length);
91 m_position = 0;
92 }
93 m_position += length;
94 }
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68
Botan::buffer_insert
size_t buffer_insert(std::vector< T, Alloc > &buf, size_t buf_offset, const T input[], size_t input_length)
Definition: secmem.h:133

The documentation for this class was generated from the following files:

- src/lib/filters/codec_filt/hex_filt.h
- src/lib/filters/codec_filt/hex_filt.cpp